import type { MutableRefObject } from 'react';
import { type ReactNode } from 'react';
import type { ImageResizeMode, ImageSourcePropType, ImageStyle, StyleProp } from 'react-native';
import { Animated } from 'react-native';
import type { OnMove, OnTap, RenderImageComponentParams } from '../../../../types';
interface Props {
    readonly renderToHardwareTextureAndroid: boolean;
    readonly windowWidth: number;
    readonly windowHeight: number;
    readonly source: ImageSourcePropType;
    readonly resizeMode?: ImageResizeMode;
    readonly imageStyle?: StyleProp<ImageStyle>;
    readonly swipeToDismiss: boolean;
    readonly isAnimated: MutableRefObject<boolean>;
    readonly animationDuration: number;
    readonly animatedOpacity: Animated.Value;
    readonly animatedScale: Animated.Value;
    readonly animatedPosition: Animated.ValueXY;
    readonly animatedImagePosition: Animated.ValueXY;
    readonly animatedImageWidth: Animated.Value;
    readonly animatedImageHeight: Animated.Value;
    readonly isModalOpen: boolean;
    renderImageComponent?(params: RenderImageComponentParams): ReactNode;
    onClose(): void;
    onDoubleTap?(): void;
    onLongPress?(): void;
    responderRelease?(vx?: number, scale?: number): void;
    onTap?(eventParams: OnTap): void;
    onMove?(position: OnMove): void;
}
declare const ImageArea: ({ renderToHardwareTextureAndroid, windowWidth, windowHeight, source, resizeMode, imageStyle, swipeToDismiss, isAnimated, animationDuration, animatedOpacity, animatedScale, animatedPosition, animatedImagePosition, animatedImageWidth, animatedImageHeight, isModalOpen, renderImageComponent, onClose, onDoubleTap, onLongPress, onTap, onMove, responderRelease, }: Props) => import("react/jsx-runtime").JSX.Element;
export { ImageArea };
//# sourceMappingURL=index.d.ts.map