var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx } from "react/jsx-runtime";
import { useRef } from 'react';
import { StyleSheet, Image, PanResponder, View } from 'react-native';
import { Animated } from 'react-native';
import { VISIBLE_OPACITY, getCenterPositionBetweenTouches, getDistanceBetweenTouches, getDistanceFromLastPosition, getMaxPosition, getOpacityFromSwipe, getImagePositionFromDistanceInScale, getPositionFromDistanceInScale, getZoomAndPositionFromDoubleTap, getZoomFromDistance, } from './utils';
var INITIAL_SCALE = 1;
var LONG_PRESS_TIME = 800;
var DOUBLE_CLICK_INTERVAL = 250;
var CLICK_DISTANCE = 10;
var DRAG_DISMISS_THRESHOLD = 150;
var INITIAL_ZOOM_DISTANCE = -1;
var styles = StyleSheet.create({
    image: {
        width: '100%',
        height: '100%',
    },
});
var ImageArea = function (_a) {
    var renderToHardwareTextureAndroid = _a.renderToHardwareTextureAndroid, windowWidth = _a.windowWidth, windowHeight = _a.windowHeight, source = _a.source, resizeMode = _a.resizeMode, imageStyle = _a.imageStyle, swipeToDismiss = _a.swipeToDismiss, isAnimated = _a.isAnimated, animationDuration = _a.animationDuration, animatedOpacity = _a.animatedOpacity, animatedScale = _a.animatedScale, animatedPosition = _a.animatedPosition, animatedImagePosition = _a.animatedImagePosition, animatedImageWidth = _a.animatedImageWidth, animatedImageHeight = _a.animatedImageHeight, isModalOpen = _a.isModalOpen, renderImageComponent = _a.renderImageComponent, onClose = _a.onClose, onDoubleTap = _a.onDoubleTap, onLongPress = _a.onLongPress, onTap = _a.onTap, onMove = _a.onMove, responderRelease = _a.responderRelease;
    var _scale = useRef(INITIAL_SCALE);
    var _position = useRef({ x: 0, y: 0 });
    var _lastPosition = useRef({ x: 0, y: 0 });
    var _centerPosition = useRef({ x: 0, y: 0 });
    var _zoomCurrentDistance = useRef(INITIAL_ZOOM_DISTANCE);
    var _zoomLastDistance = useRef(INITIAL_ZOOM_DISTANCE);
    var _lastClickTime = useRef(0);
    var _isDoubleClick = useRef(false);
    var _isLongPress = useRef(false);
    var _singleTapTimeout = useRef(undefined);
    var _longPressTimeout = useRef(undefined);
    var clearLongPressTimeout = function () {
        if (_longPressTimeout.current) {
            clearTimeout(_longPressTimeout.current);
            _longPressTimeout.current = undefined;
        }
    };
    var clearSingleTapTimeout = function () {
        if (_singleTapTimeout.current) {
            clearTimeout(_singleTapTimeout.current);
            _singleTapTimeout.current = undefined;
        }
    };
    var moveImageToGesture = function (gestureState) {
        clearLongPressTimeout();
        var dx = gestureState.dx, dy = gestureState.dy;
        var newDistance = getDistanceFromLastPosition(_lastPosition.current, { dx: dx, dy: dy });
        _lastPosition.current = { x: dx, y: dy };
        var scale = _scale.current;
        _position.current = getImagePositionFromDistanceInScale(scale, _position.current, newDistance);
        animatedPosition.setValue(_position.current);
        var opacity = getOpacityFromSwipe({
            swipeToDismiss: swipeToDismiss,
            scale: scale,
            dy: dy,
            windowHeight: windowHeight,
        });
        animatedOpacity.setValue(opacity);
    };
    var pinchZoom = function (event) {
        clearLongPressTimeout();
        _zoomCurrentDistance.current = getDistanceBetweenTouches(event.nativeEvent.changedTouches[0], event.nativeEvent.changedTouches[1]);
        if (_zoomLastDistance.current !== INITIAL_ZOOM_DISTANCE) {
            var distanceDiff = (_zoomCurrentDistance.current - _zoomLastDistance.current) / 200;
            var zoom = getZoomFromDistance(_scale.current, distanceDiff);
            _scale.current = zoom;
            animatedScale.setValue(_scale.current);
            _position.current = getPositionFromDistanceInScale({
                currentPosition: _position.current,
                centerDiff: _centerPosition.current,
                distanceDiff: distanceDiff,
                zoom: zoom,
            });
            animatedPosition.setValue(_position.current);
        }
        _zoomLastDistance.current = _zoomCurrentDistance.current;
    };
    var triggerOnMove = function (type) {
        var _a = _position.current, positionX = _a.x, positionY = _a.y;
        onMove === null || onMove === void 0 ? void 0 : onMove({
            type: type,
            positionX: positionX,
            positionY: positionY,
            scale: _scale.current,
            zoomCurrentDistance: _zoomCurrentDistance.current,
        });
    };
    var animateToPosition = function (position) {
        _position.current = position;
        Animated.timing(animatedPosition, {
            toValue: _position.current,
            duration: animationDuration,
            useNativeDriver: false,
        }).start();
    };
    var animateToScale = function (scale) {
        _scale.current = scale;
        Animated.timing(animatedScale, {
            toValue: _scale.current,
            duration: animationDuration,
            useNativeDriver: false,
        }).start();
    };
    var handlePanResponderReleaseResolve = function (changedTouchesCount) {
        if (_scale.current < INITIAL_SCALE) {
            animateToPosition({ x: 0, y: 0 });
            return;
        }
        if (_scale.current > INITIAL_SCALE) {
            var position = getMaxPosition(_scale.current, _position.current, {
                width: windowWidth,
                height: windowHeight,
            });
            animateToPosition(position);
            return;
        }
        if (swipeToDismiss &&
            changedTouchesCount === 1 &&
            Math.abs(_position.current.y) > DRAG_DISMISS_THRESHOLD) {
            onClose();
            return;
        }
        animateToPosition({ x: 0, y: 0 });
        Animated.timing(animatedOpacity, {
            toValue: VISIBLE_OPACITY,
            duration: animationDuration,
            useNativeDriver: false,
        }).start();
        triggerOnMove('onPanResponderRelease');
    };
    var handlePanResponderGrant = function (event) {
        if (isAnimated.current) {
            return;
        }
        _lastPosition.current = { x: 0, y: 0 };
        _zoomLastDistance.current = INITIAL_ZOOM_DISTANCE;
        _isDoubleClick.current = false;
        _isLongPress.current = false;
        clearSingleTapTimeout();
        clearLongPressTimeout();
        _longPressTimeout.current = setTimeout(function () {
            _isLongPress.current = true;
            onLongPress === null || onLongPress === void 0 ? void 0 : onLongPress();
        }, LONG_PRESS_TIME);
        if (event.nativeEvent.changedTouches.length > 1) {
            _centerPosition.current = getCenterPositionBetweenTouches(event.nativeEvent.changedTouches[0], event.nativeEvent.changedTouches[1], { width: windowWidth, height: windowHeight });
        }
        if (event.nativeEvent.changedTouches.length <= 1) {
            if (new Date().getTime() - _lastClickTime.current < DOUBLE_CLICK_INTERVAL) {
                _lastClickTime.current = 0;
                _isDoubleClick.current = true;
                var _a = getZoomAndPositionFromDoubleTap(_scale.current, event.nativeEvent.changedTouches[0], { width: windowWidth, height: windowHeight }), scale = _a.scale, position = _a.position;
                animateToPosition(position);
                animateToScale(scale);
                triggerOnMove('centerOn');
                onDoubleTap === null || onDoubleTap === void 0 ? void 0 : onDoubleTap();
            }
            else {
                _lastClickTime.current = new Date().getTime();
            }
        }
    };
    var handlePanResponderMove = function (event, gestureState) {
        if (_isDoubleClick.current || isAnimated.current) {
            return;
        }
        if (event.nativeEvent.changedTouches.length <= 1) {
            moveImageToGesture(gestureState);
        }
        else {
            pinchZoom(event);
        }
        triggerOnMove('onPanResponderMove');
    };
    var handlePanResponderRelease = function (event, gestureState) {
        clearLongPressTimeout();
        if (_isDoubleClick.current || _isLongPress.current || isAnimated.current) {
            return;
        }
        var moveDistance = Math.sqrt(gestureState.dx * gestureState.dx + gestureState.dy * gestureState.dy);
        if (event.nativeEvent.changedTouches.length === 1 && moveDistance < CLICK_DISTANCE) {
            _singleTapTimeout.current = setTimeout(function () {
                onTap === null || onTap === void 0 ? void 0 : onTap(event.nativeEvent);
            }, DOUBLE_CLICK_INTERVAL);
        }
        else {
            handlePanResponderReleaseResolve(event.nativeEvent.changedTouches.length);
            responderRelease === null || responderRelease === void 0 ? void 0 : responderRelease(gestureState.vx, _scale.current);
        }
    };
    var _imagePanResponder = PanResponder.create({
        onStartShouldSetPanResponder: function () { return true; },
        onPanResponderTerminationRequest: function () { return false; },
        onPanResponderGrant: handlePanResponderGrant,
        onPanResponderMove: handlePanResponderMove,
        onPanResponderRelease: handlePanResponderRelease,
    });
    return (_jsx(View, __assign({ style: {
            overflow: 'hidden',
            flex: 1,
        } }, _imagePanResponder === null || _imagePanResponder === void 0 ? void 0 : _imagePanResponder.panHandlers, { children: _jsx(Animated.View, { style: {
                transform: [
                    {
                        scale: animatedScale,
                    },
                    {
                        translateX: animatedPosition.x,
                    },
                    {
                        translateY: animatedPosition.y,
                    },
                ],
                left: animatedImagePosition.x,
                top: animatedImagePosition.y,
                width: animatedImageWidth,
                height: animatedImageHeight,
            }, renderToHardwareTextureAndroid: renderToHardwareTextureAndroid, children: typeof renderImageComponent === 'function' ? (renderImageComponent({
                source: source,
                resizeMode: resizeMode,
                style: [imageStyle, styles.image],
                isModalOpen: isModalOpen,
            })) : (_jsx(Image, { resizeMode: resizeMode, style: [imageStyle, styles.image], source: source })) }) })));
};
export { ImageArea };
//# sourceMappingURL=index.js.map