import type { ReactNode } from 'react';
import type { ImageResizeMode, StyleProp, ImageStyle, ImageSourcePropType } from 'react-native';
import type { OnTap, OnMove, RenderImageComponentParams } from '../../types';
interface ImageDetail {
    close(): void;
}
interface Props {
    readonly renderToHardwareTextureAndroid: boolean;
    readonly isTranslucent?: boolean;
    readonly isOpen: boolean;
    readonly origin: {
        readonly x: number;
        readonly y: number;
        readonly width: number;
        readonly height: number;
    };
    readonly source: ImageSourcePropType;
    readonly resizeMode?: ImageResizeMode;
    readonly backgroundColor?: string;
    readonly swipeToDismiss: boolean;
    readonly hideCloseButton?: boolean;
    readonly imageStyle?: StyleProp<ImageStyle>;
    readonly parentLayout?: {
        readonly x: number;
        readonly y: number;
        readonly width: number;
        readonly height: number;
    };
    readonly animationDuration: number;
    renderHeader?(close: () => void): ReactNode;
    renderFooter?(close: () => void): ReactNode;
    renderImageComponent?(params: RenderImageComponentParams): ReactNode;
    onTap?(eventParams: OnTap): void;
    onDoubleTap?(): void;
    onLongPress?(): void;
    didOpen?(): void;
    onMove?(position: OnMove): void;
    responderRelease?(vx?: number, scale?: number): void;
    willClose?(): void;
    onClose(): void;
}
declare const ImageDetail: import("react").ForwardRefExoticComponent<Props & import("react").RefAttributes<ImageDetail>>;
export { ImageDetail };
//# sourceMappingURL=index.d.ts.map